"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionsOrganizationOidcSubjectClaimCustomizationTemplate = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * This resource allows you to create and manage an OpenID Connect subject claim customization template within a GitHub
 * organization.
 *
 * More information on integrating GitHub with cloud providers using OpenID Connect and a list of available claims is
 * available in the [Actions documentation](https://docs.github.com/en/actions/deployment/security-hardening-your-deployments/about-security-hardening-with-openid-connect).
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const exampleTemplate = new github.ActionsOrganizationOidcSubjectClaimCustomizationTemplate("example_template", {includeClaimKeys: [
 *     "actor",
 *     "context",
 *     "repository_owner",
 * ]});
 * ```
 *
 * ## Import
 *
 * This resource can be imported using the organization's name.
 *
 * ```sh
 * $ pulumi import github:index/actionsOrganizationOidcSubjectClaimCustomizationTemplate:ActionsOrganizationOidcSubjectClaimCustomizationTemplate test example_organization
 * ```
 */
class ActionsOrganizationOidcSubjectClaimCustomizationTemplate extends pulumi.CustomResource {
    /**
     * Get an existing ActionsOrganizationOidcSubjectClaimCustomizationTemplate resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ActionsOrganizationOidcSubjectClaimCustomizationTemplate(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ActionsOrganizationOidcSubjectClaimCustomizationTemplate.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ActionsOrganizationOidcSubjectClaimCustomizationTemplate.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["includeClaimKeys"] = state ? state.includeClaimKeys : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.includeClaimKeys === undefined) && !opts.urn) {
                throw new Error("Missing required property 'includeClaimKeys'");
            }
            resourceInputs["includeClaimKeys"] = args ? args.includeClaimKeys : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(ActionsOrganizationOidcSubjectClaimCustomizationTemplate.__pulumiType, name, resourceInputs, opts);
    }
}
exports.ActionsOrganizationOidcSubjectClaimCustomizationTemplate = ActionsOrganizationOidcSubjectClaimCustomizationTemplate;
/** @internal */
ActionsOrganizationOidcSubjectClaimCustomizationTemplate.__pulumiType = 'github:index/actionsOrganizationOidcSubjectClaimCustomizationTemplate:ActionsOrganizationOidcSubjectClaimCustomizationTemplate';
//# sourceMappingURL=actionsOrganizationOidcSubjectClaimCustomizationTemplate.js.map