import * as outputs from "../types/output";
/**
 * The GitHub App credentials used to connect to GitHub. Conflicts with `token`. Anonymous mode is enabled if both `token`
 * and `appAuth` are not set.
 */
export declare const appAuth: outputs.config.AppAuth | undefined;
/**
 * The GitHub Base API URL
 */
export declare const baseUrl: string;
/**
 * Enable `insecure` mode for testing purposes
 */
export declare const insecure: boolean | undefined;
/**
 * Number of times to retry a request after receiving an error status codeDefaults to 3
 */
export declare const maxRetries: number | undefined;
/**
 * The GitHub organization name to manage. Use this field instead of `owner` when managing organization accounts.
 */
export declare const organization: string | undefined;
/**
 * The GitHub owner name to manage. Use this field instead of `organization` when managing individual accounts.
 */
export declare const owner: string | undefined;
/**
 * Allow the provider to make parallel API calls to GitHub. You may want to set it to true when you have a private Github
 * Enterprise without strict rate limits. Although, it is not possible to enable this setting on github.com because we
 * enforce the respect of github.com's best practices to avoid hitting abuse rate limitsDefaults to false if not set
 */
export declare const parallelRequests: boolean | undefined;
/**
 * Amount of time in milliseconds to sleep in between non-write requests to GitHub API. Defaults to 0ms if not set.
 */
export declare const readDelayMs: number | undefined;
/**
 * Amount of time in milliseconds to sleep in between requests to GitHub API after an error response. Defaults to 1000ms or
 * 1s if not set, the maxRetries must be set to greater than zero.
 */
export declare const retryDelayMs: number | undefined;
/**
 * Allow the provider to retry after receiving an error status code, the maxRetries should be set for this to workDefaults
 * to [500, 502, 503, 504]
 */
export declare const retryableErrors: number[] | undefined;
/**
 * The OAuth token used to connect to GitHub. Anonymous mode is enabled if both `token` and `appAuth` are not set.
 */
export declare const token: string | undefined;
/**
 * Amount of time in milliseconds to sleep in between writes to GitHub API. Defaults to 1000ms or 1s if not set.
 */
export declare const writeDelayMs: number | undefined;
