import * as pulumi from "@pulumi/pulumi";
/**
 * Use this data source to retrieve the OpenID Connect subject claim customization template for an organization
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getActionsOrganizationOidcSubjectClaimCustomizationTemplate({});
 * ```
 */
export declare function getActionsOrganizationOidcSubjectClaimCustomizationTemplate(opts?: pulumi.InvokeOptions): Promise<GetActionsOrganizationOidcSubjectClaimCustomizationTemplateResult>;
/**
 * A collection of values returned by getActionsOrganizationOidcSubjectClaimCustomizationTemplate.
 */
export interface GetActionsOrganizationOidcSubjectClaimCustomizationTemplateResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * The list of OpenID Connect claim keys.
     */
    readonly includeClaimKeys: string[];
}
/**
 * Use this data source to retrieve the OpenID Connect subject claim customization template for an organization
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getActionsOrganizationOidcSubjectClaimCustomizationTemplate({});
 * ```
 */
export declare function getActionsOrganizationOidcSubjectClaimCustomizationTemplateOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetActionsOrganizationOidcSubjectClaimCustomizationTemplateResult>;
