import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve the list of secrets of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getActionsOrganizationSecrets({});
 * ```
 */
export declare function getActionsOrganizationSecrets(opts?: pulumi.InvokeOptions): Promise<GetActionsOrganizationSecretsResult>;
/**
 * A collection of values returned by getActionsOrganizationSecrets.
 */
export interface GetActionsOrganizationSecretsResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * list of secrets for the repository
     */
    readonly secrets: outputs.GetActionsOrganizationSecretsSecret[];
}
/**
 * Use this data source to retrieve the list of secrets of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getActionsOrganizationSecrets({});
 * ```
 */
export declare function getActionsOrganizationSecretsOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetActionsOrganizationSecretsResult>;
