import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve the list of variables of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getActionsOrganizationVariables({});
 * ```
 */
export declare function getActionsOrganizationVariables(opts?: pulumi.InvokeOptions): Promise<GetActionsOrganizationVariablesResult>;
/**
 * A collection of values returned by getActionsOrganizationVariables.
 */
export interface GetActionsOrganizationVariablesResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * list of variables for the repository
     */
    readonly variables: outputs.GetActionsOrganizationVariablesVariable[];
}
/**
 * Use this data source to retrieve the list of variables of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getActionsOrganizationVariables({});
 * ```
 */
export declare function getActionsOrganizationVariablesOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetActionsOrganizationVariablesResult>;
