import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve the list of codespaces secrets of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getCodespacesOrganizationSecrets({});
 * ```
 */
export declare function getCodespacesOrganizationSecrets(opts?: pulumi.InvokeOptions): Promise<GetCodespacesOrganizationSecretsResult>;
/**
 * A collection of values returned by getCodespacesOrganizationSecrets.
 */
export interface GetCodespacesOrganizationSecretsResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * list of secrets for the repository
     */
    readonly secrets: outputs.GetCodespacesOrganizationSecretsSecret[];
}
/**
 * Use this data source to retrieve the list of codespaces secrets of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getCodespacesOrganizationSecrets({});
 * ```
 */
export declare function getCodespacesOrganizationSecretsOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetCodespacesOrganizationSecretsResult>;
