import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve the list of codespaces secrets of the user.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getCodespacesUserSecrets({});
 * ```
 */
export declare function getCodespacesUserSecrets(opts?: pulumi.InvokeOptions): Promise<GetCodespacesUserSecretsResult>;
/**
 * A collection of values returned by getCodespacesUserSecrets.
 */
export interface GetCodespacesUserSecretsResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * list of secrets for the repository
     */
    readonly secrets: outputs.GetCodespacesUserSecretsSecret[];
}
/**
 * Use this data source to retrieve the list of codespaces secrets of the user.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getCodespacesUserSecrets({});
 * ```
 */
export declare function getCodespacesUserSecretsOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetCodespacesUserSecretsResult>;
