import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve the list of dependabot secrets of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getDependabotOrganizationSecrets({});
 * ```
 */
export declare function getDependabotOrganizationSecrets(opts?: pulumi.InvokeOptions): Promise<GetDependabotOrganizationSecretsResult>;
/**
 * A collection of values returned by getDependabotOrganizationSecrets.
 */
export interface GetDependabotOrganizationSecretsResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * list of secrets for the repository
     */
    readonly secrets: outputs.GetDependabotOrganizationSecretsSecret[];
}
/**
 * Use this data source to retrieve the list of dependabot secrets of the organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const example = github.getDependabotOrganizationSecrets({});
 * ```
 */
export declare function getDependabotOrganizationSecretsOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetDependabotOrganizationSecretsResult>;
