import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve the labels for a given repository.
 */
export declare function getIssueLabels(args: GetIssueLabelsArgs, opts?: pulumi.InvokeOptions): Promise<GetIssueLabelsResult>;
/**
 * A collection of arguments for invoking getIssueLabels.
 */
export interface GetIssueLabelsArgs {
    /**
     * The name of the repository.
     */
    repository: string;
}
/**
 * A collection of values returned by getIssueLabels.
 */
export interface GetIssueLabelsResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * The list of this repository's labels. Each element of `labels` has the following attributes:
     */
    readonly labels: outputs.GetIssueLabelsLabel[];
    readonly repository: string;
}
/**
 * Use this data source to retrieve the labels for a given repository.
 */
export declare function getIssueLabelsOutput(args: GetIssueLabelsOutputArgs, opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetIssueLabelsResult>;
/**
 * A collection of arguments for invoking getIssueLabels.
 */
export interface GetIssueLabelsOutputArgs {
    /**
     * The name of the repository.
     */
    repository: pulumi.Input<string>;
}
