import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve each organization member's SAML or SCIM user
 * attributes.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const all = github.getOrganizationExternalIdentities({});
 * ```
 */
export declare function getOrganizationExternalIdentities(opts?: pulumi.InvokeOptions): Promise<GetOrganizationExternalIdentitiesResult>;
/**
 * A collection of values returned by getOrganizationExternalIdentities.
 */
export interface GetOrganizationExternalIdentitiesResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * An Array of identities returned from GitHub
     */
    readonly identities: outputs.GetOrganizationExternalIdentitiesIdentity[];
}
/**
 * Use this data source to retrieve each organization member's SAML or SCIM user
 * attributes.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const all = github.getOrganizationExternalIdentities({});
 * ```
 */
export declare function getOrganizationExternalIdentitiesOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetOrganizationExternalIdentitiesResult>;
