import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve all webhooks of the organization.
 *
 * ## Example Usage
 *
 * To retrieve *all* webhooks of the organization:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const all = github.getOrganizationWebhooks({});
 * ```
 */
export declare function getOrganizationWebhooks(opts?: pulumi.InvokeOptions): Promise<GetOrganizationWebhooksResult>;
/**
 * A collection of values returned by getOrganizationWebhooks.
 */
export interface GetOrganizationWebhooksResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * An Array of GitHub Webhooks.  Each `webhook` block consists of the fields documented below.
     * ___
     */
    readonly webhooks: outputs.GetOrganizationWebhooksWebhook[];
}
/**
 * Use this data source to retrieve all webhooks of the organization.
 *
 * ## Example Usage
 *
 * To retrieve *all* webhooks of the organization:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const all = github.getOrganizationWebhooks({});
 * ```
 */
export declare function getOrganizationWebhooksOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetOrganizationWebhooksResult>;
