import * as pulumi from "@pulumi/pulumi";
/**
 * Use this data source to retrieve information about GitHub's SSH keys.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const test = github.getSshKeys({});
 * ```
 */
export declare function getSshKeys(opts?: pulumi.InvokeOptions): Promise<GetSshKeysResult>;
/**
 * A collection of values returned by getSshKeys.
 */
export interface GetSshKeysResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * An array of GitHub's SSH public keys.
     */
    readonly keys: string[];
}
/**
 * Use this data source to retrieve information about GitHub's SSH keys.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const test = github.getSshKeys({});
 * ```
 */
export declare function getSshKeysOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetSshKeysResult>;
