"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrganizationSettings = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * This resource allows you to create and manage settings for a GitHub Organization.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const test = new github.OrganizationSettings("test", {
 *     billingEmail: "test@example.com",
 *     company: "Test Company",
 *     blog: "https://example.com",
 *     email: "test@example.com",
 *     twitterUsername: "Test",
 *     location: "Test Location",
 *     name: "Test Name",
 *     description: "Test Description",
 *     hasOrganizationProjects: true,
 *     hasRepositoryProjects: true,
 *     defaultRepositoryPermission: "read",
 *     membersCanCreateRepositories: true,
 *     membersCanCreatePublicRepositories: true,
 *     membersCanCreatePrivateRepositories: true,
 *     membersCanCreateInternalRepositories: true,
 *     membersCanCreatePages: true,
 *     membersCanCreatePublicPages: true,
 *     membersCanCreatePrivatePages: true,
 *     membersCanForkPrivateRepositories: true,
 *     webCommitSignoffRequired: true,
 *     advancedSecurityEnabledForNewRepositories: false,
 *     dependabotAlertsEnabledForNewRepositories: false,
 *     dependabotSecurityUpdatesEnabledForNewRepositories: false,
 *     dependencyGraphEnabledForNewRepositories: false,
 *     secretScanningEnabledForNewRepositories: false,
 *     secretScanningPushProtectionEnabledForNewRepositories: false,
 * });
 * ```
 *
 * ## Import
 *
 * Organization settings can be imported using the `id` of the organization.
 * The `id` of the organization can be found using the [get an organization](https://docs.github.com/en/rest/orgs/orgs#get-an-organization) API.
 *
 * ```sh
 * $ pulumi import github:index/organizationSettings:OrganizationSettings test 123456789
 * ```
 */
class OrganizationSettings extends pulumi.CustomResource {
    /**
     * Get an existing OrganizationSettings resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new OrganizationSettings(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of OrganizationSettings.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === OrganizationSettings.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["advancedSecurityEnabledForNewRepositories"] = state ? state.advancedSecurityEnabledForNewRepositories : undefined;
            resourceInputs["billingEmail"] = state ? state.billingEmail : undefined;
            resourceInputs["blog"] = state ? state.blog : undefined;
            resourceInputs["company"] = state ? state.company : undefined;
            resourceInputs["defaultRepositoryPermission"] = state ? state.defaultRepositoryPermission : undefined;
            resourceInputs["dependabotAlertsEnabledForNewRepositories"] = state ? state.dependabotAlertsEnabledForNewRepositories : undefined;
            resourceInputs["dependabotSecurityUpdatesEnabledForNewRepositories"] = state ? state.dependabotSecurityUpdatesEnabledForNewRepositories : undefined;
            resourceInputs["dependencyGraphEnabledForNewRepositories"] = state ? state.dependencyGraphEnabledForNewRepositories : undefined;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["email"] = state ? state.email : undefined;
            resourceInputs["hasOrganizationProjects"] = state ? state.hasOrganizationProjects : undefined;
            resourceInputs["hasRepositoryProjects"] = state ? state.hasRepositoryProjects : undefined;
            resourceInputs["location"] = state ? state.location : undefined;
            resourceInputs["membersCanCreateInternalRepositories"] = state ? state.membersCanCreateInternalRepositories : undefined;
            resourceInputs["membersCanCreatePages"] = state ? state.membersCanCreatePages : undefined;
            resourceInputs["membersCanCreatePrivatePages"] = state ? state.membersCanCreatePrivatePages : undefined;
            resourceInputs["membersCanCreatePrivateRepositories"] = state ? state.membersCanCreatePrivateRepositories : undefined;
            resourceInputs["membersCanCreatePublicPages"] = state ? state.membersCanCreatePublicPages : undefined;
            resourceInputs["membersCanCreatePublicRepositories"] = state ? state.membersCanCreatePublicRepositories : undefined;
            resourceInputs["membersCanCreateRepositories"] = state ? state.membersCanCreateRepositories : undefined;
            resourceInputs["membersCanForkPrivateRepositories"] = state ? state.membersCanForkPrivateRepositories : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["secretScanningEnabledForNewRepositories"] = state ? state.secretScanningEnabledForNewRepositories : undefined;
            resourceInputs["secretScanningPushProtectionEnabledForNewRepositories"] = state ? state.secretScanningPushProtectionEnabledForNewRepositories : undefined;
            resourceInputs["twitterUsername"] = state ? state.twitterUsername : undefined;
            resourceInputs["webCommitSignoffRequired"] = state ? state.webCommitSignoffRequired : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.billingEmail === undefined) && !opts.urn) {
                throw new Error("Missing required property 'billingEmail'");
            }
            resourceInputs["advancedSecurityEnabledForNewRepositories"] = args ? args.advancedSecurityEnabledForNewRepositories : undefined;
            resourceInputs["billingEmail"] = args ? args.billingEmail : undefined;
            resourceInputs["blog"] = args ? args.blog : undefined;
            resourceInputs["company"] = args ? args.company : undefined;
            resourceInputs["defaultRepositoryPermission"] = args ? args.defaultRepositoryPermission : undefined;
            resourceInputs["dependabotAlertsEnabledForNewRepositories"] = args ? args.dependabotAlertsEnabledForNewRepositories : undefined;
            resourceInputs["dependabotSecurityUpdatesEnabledForNewRepositories"] = args ? args.dependabotSecurityUpdatesEnabledForNewRepositories : undefined;
            resourceInputs["dependencyGraphEnabledForNewRepositories"] = args ? args.dependencyGraphEnabledForNewRepositories : undefined;
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["email"] = args ? args.email : undefined;
            resourceInputs["hasOrganizationProjects"] = args ? args.hasOrganizationProjects : undefined;
            resourceInputs["hasRepositoryProjects"] = args ? args.hasRepositoryProjects : undefined;
            resourceInputs["location"] = args ? args.location : undefined;
            resourceInputs["membersCanCreateInternalRepositories"] = args ? args.membersCanCreateInternalRepositories : undefined;
            resourceInputs["membersCanCreatePages"] = args ? args.membersCanCreatePages : undefined;
            resourceInputs["membersCanCreatePrivatePages"] = args ? args.membersCanCreatePrivatePages : undefined;
            resourceInputs["membersCanCreatePrivateRepositories"] = args ? args.membersCanCreatePrivateRepositories : undefined;
            resourceInputs["membersCanCreatePublicPages"] = args ? args.membersCanCreatePublicPages : undefined;
            resourceInputs["membersCanCreatePublicRepositories"] = args ? args.membersCanCreatePublicRepositories : undefined;
            resourceInputs["membersCanCreateRepositories"] = args ? args.membersCanCreateRepositories : undefined;
            resourceInputs["membersCanForkPrivateRepositories"] = args ? args.membersCanForkPrivateRepositories : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["secretScanningEnabledForNewRepositories"] = args ? args.secretScanningEnabledForNewRepositories : undefined;
            resourceInputs["secretScanningPushProtectionEnabledForNewRepositories"] = args ? args.secretScanningPushProtectionEnabledForNewRepositories : undefined;
            resourceInputs["twitterUsername"] = args ? args.twitterUsername : undefined;
            resourceInputs["webCommitSignoffRequired"] = args ? args.webCommitSignoffRequired : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(OrganizationSettings.__pulumiType, name, resourceInputs, opts);
    }
}
exports.OrganizationSettings = OrganizationSettings;
/** @internal */
OrganizationSettings.__pulumiType = 'github:index/organizationSettings:OrganizationSettings';
//# sourceMappingURL=organizationSettings.js.map