"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.RepositoryDependabotSecurityUpdates = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * This resource allows you to manage dependabot automated security fixes for a single repository. See the
 * [documentation](https://docs.github.com/en/code-security/dependabot/dependabot-security-updates/about-dependabot-security-updates)
 * for details of usage and how this will impact your repository
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const repo = new github.Repository("repo", {
 *     name: "my-repo",
 *     description: "GitHub repo managed by Terraform",
 *     "private": false,
 *     vulnerabilityAlerts: true,
 * });
 * const example = new github.RepositoryDependabotSecurityUpdates("example", {
 *     repository: test.name,
 *     enabled: true,
 * });
 * ```
 *
 * ## Import
 *
 * ### Import by name
 *
 * ```sh
 * $ pulumi import github:index/repositoryDependabotSecurityUpdates:RepositoryDependabotSecurityUpdates example my-repo
 * ```
 */
class RepositoryDependabotSecurityUpdates extends pulumi.CustomResource {
    /**
     * Get an existing RepositoryDependabotSecurityUpdates resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new RepositoryDependabotSecurityUpdates(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of RepositoryDependabotSecurityUpdates.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === RepositoryDependabotSecurityUpdates.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["enabled"] = state ? state.enabled : undefined;
            resourceInputs["repository"] = state ? state.repository : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.enabled === undefined) && !opts.urn) {
                throw new Error("Missing required property 'enabled'");
            }
            if ((!args || args.repository === undefined) && !opts.urn) {
                throw new Error("Missing required property 'repository'");
            }
            resourceInputs["enabled"] = args ? args.enabled : undefined;
            resourceInputs["repository"] = args ? args.repository : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(RepositoryDependabotSecurityUpdates.__pulumiType, name, resourceInputs, opts);
    }
}
exports.RepositoryDependabotSecurityUpdates = RepositoryDependabotSecurityUpdates;
/** @internal */
RepositoryDependabotSecurityUpdates.__pulumiType = 'github:index/repositoryDependabotSecurityUpdates:RepositoryDependabotSecurityUpdates';
//# sourceMappingURL=repositoryDependabotSecurityUpdates.js.map