"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.RepositoryTopics = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as github from "@pulumi/github";
 *
 * const test = github.getRepository({
 *     name: "test",
 * });
 * const testRepositoryTopics = new github.RepositoryTopics("test", {
 *     repository: testGithubRepository.name,
 *     topics: [
 *         "topic-1",
 *         "topic-2",
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * Repository topics can be imported using the `name` of the repository.
 *
 * ```sh
 * $ pulumi import github:index/repositoryTopics:RepositoryTopics terraform terraform
 * ```
 */
class RepositoryTopics extends pulumi.CustomResource {
    /**
     * Get an existing RepositoryTopics resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new RepositoryTopics(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of RepositoryTopics.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === RepositoryTopics.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["repository"] = state ? state.repository : undefined;
            resourceInputs["topics"] = state ? state.topics : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.repository === undefined) && !opts.urn) {
                throw new Error("Missing required property 'repository'");
            }
            if ((!args || args.topics === undefined) && !opts.urn) {
                throw new Error("Missing required property 'topics'");
            }
            resourceInputs["repository"] = args ? args.repository : undefined;
            resourceInputs["topics"] = args ? args.topics : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(RepositoryTopics.__pulumiType, name, resourceInputs, opts);
    }
}
exports.RepositoryTopics = RepositoryTopics;
/** @internal */
RepositoryTopics.__pulumiType = 'github:index/repositoryTopics:RepositoryTopics';
//# sourceMappingURL=repositoryTopics.js.map